package com.qmth.cqb.paper.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.qmth.cqb.paper.dto.PaperDetailInfoUnitStructBlueprintDto;
import com.qmth.cqb.utils.enums.PropertyDifficulty;

/**
 * @describle 蓝图试卷结构大题详情属性数量
 * @author weiwenhai
 * @date   2017.11.16
 */
@Entity
@Table(name = "ecs_ques_paper_detail_info_unit_struct_blueprint")
public class PaperDetailInfoUnitStructBlueprint implements Serializable {

	private static final long serialVersionUID = -8398385820281426872L;

	@Id
	@GeneratedValue
	private Long id; //id
	
	@NotNull
	private Long propertyId; //属性id
	
	private Integer number; //属性数量
	
	private boolean isPublic; //是否公开
	
	private String propertyDifficulty; //属性难度
	
	private Long paperDetailInfoStructBlueprintId; //大题详情id
	
	private Long paperDetailStructBlueprintId; //大题id
	
	public PaperDetailInfoUnitStructBlueprint(){
		
	}
	
	public PaperDetailInfoUnitStructBlueprint(PaperDetailInfoUnitStructBlueprintDto paperDetailInfoUnitStructBlueprintDto, PaperDetailInfoStructBlueprint paperDetailInfoStructBlueprint){
		this.propertyId = paperDetailInfoUnitStructBlueprintDto.getPropertyId();
		this.paperDetailInfoStructBlueprintId = paperDetailInfoStructBlueprint.getId();
		this.paperDetailStructBlueprintId = paperDetailInfoStructBlueprint.getPaperDetailStructBlueprintId();
	}
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getPropertyId() {
		return propertyId;
	}

	public void setPropertyId(Long propertyId) {
		this.propertyId = propertyId;
	}

	public Integer getNumber() {
		return number;
	}

	public void setNumber(Integer number) {
		this.number = number;
	}

	public Long getPaperDetailInfoStructBlueprintId() {
		return paperDetailInfoStructBlueprintId;
	}

	public void setPaperDetailInfoStructBlueprintId(
			Long paperDetailInfoStructBlueprintId) {
		this.paperDetailInfoStructBlueprintId = paperDetailInfoStructBlueprintId;
	}

	public Long getPaperDetailStructBlueprintId() {
		return paperDetailStructBlueprintId;
	}

	public void setPaperDetailStructBlueprintId(Long paperDetailStructBlueprintId) {
		this.paperDetailStructBlueprintId = paperDetailStructBlueprintId;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	public boolean isPublic() {
		return isPublic;
	}

	public void setIsPublic(boolean isPublic) {
		this.isPublic = isPublic;
	}

	public String getPropertyDifficulty() {
		return propertyDifficulty;
	}

	public void setPropertyDifficulty(String propertyDifficulty) {
		this.propertyDifficulty = propertyDifficulty;
	}
	
}
