package com.qmth.cqb.paper.service;

import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import com.qmth.cqb.paper.dto.PaperStructBlueprintDto;
import com.qmth.cqb.paper.model.PaperStructBlueprint;

/**
 * @describle 蓝图试卷结构 service
 * @author weiwenhai
 * @date   2017.11.17
 */
public interface PaperStructBlueprintService {

	/**
	 * 查询所有蓝图试卷结构带分页
	 * @param paperStructBlueprintDto
	 * @return
	 */
	public Page<PaperStructBlueprint> findAll(PaperStructBlueprintDto paperStructBlueprintDto, Pageable pageable);
	
	/**
	 * 保存试卷结构
	 * @param paperStructBlueprintDto
	 * @param PaperDetailIds
	 */
	public void saveSingle(PaperStructBlueprintDto paperStructBlueprintDto, String PaperDetailIds);
	
	/**
	 * 计算试卷结构难度
	 * @param ids 试卷结构大题的ids
	 * @return
	 */
	public Double getDifficulty(List<Long> ids);
	
	/**
	 * 根据id删除试卷结构
	 * @param id
	 */
	public void deleteSingle(Long id);
	
	/**
	 * 根据课程查询查询试卷结构
	 * @param courseNo
	 * @return
	 */
	public List<PaperStructBlueprint> findByCourseNo(String courseNo);
}
