package com.qmth.cqb.paper.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import com.qmth.cqb.paper.dao.PaperDetailInfoUnitStructBlueprintRepo;
import com.qmth.cqb.paper.model.PaperDetailInfoUnitStructBlueprint;
import com.qmth.cqb.paper.service.PaperDetailInfoUnitStructBlueprintService;

/**
 * @describle 蓝图试卷结构大题详情属性数量  paperDetailInfoUnitStructBlueprintServiceImpl
 * @author weiwenhai
 * @date   2017.11.20
 */
@Service("paperDetailInfoUnitStructBlueprintService")
public class PaperDetailInfoUnitStructBlueprintServiceImpl implements PaperDetailInfoUnitStructBlueprintService{
	
	@Autowired
	private PaperDetailInfoUnitStructBlueprintRepo paperDetailInfoUnitStructBlueprintRepo;

	@Override
	public void saveSingle(PaperDetailInfoUnitStructBlueprint paperDetailInfoUnitStructBlueprint) {
		if(!StringUtils.isEmpty(paperDetailInfoUnitStructBlueprint.getPropertyId())){
			paperDetailInfoUnitStructBlueprintRepo.save(paperDetailInfoUnitStructBlueprint);
		}
	}

	@Override
	public List<PaperDetailInfoUnitStructBlueprint> getPaperDetailInfoUnitStructBlueprint(Long paperDetailInfoStructBlueprintId, Long paperDetailStructBlueprintId) {
		List<PaperDetailInfoUnitStructBlueprint> paperDetailInfoUnitStructBlueprints = paperDetailInfoUnitStructBlueprintRepo.findByPaperDetailInfoStructBlueprintIdAndPaperDetailStructBlueprintId(paperDetailInfoStructBlueprintId, paperDetailStructBlueprintId);
		return paperDetailInfoUnitStructBlueprints;
	}

	@Override
	public void deleteSingle(PaperDetailInfoUnitStructBlueprint paperDetailInfoUnitStructBlueprint) {
		paperDetailInfoUnitStructBlueprintRepo.delete(paperDetailInfoUnitStructBlueprint);
	}

}
