package com.qmth.cqb.paper.web;

import javax.servlet.http.HttpServletRequest;

import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import cn.com.qmth.examcloud.common.uac.entity.AccessUser;

import com.qmth.cqb.paper.dto.PaperDetailInfoStructBlueprintDto;
import com.qmth.cqb.paper.service.PaperDetailInfoStructBlueprintService;

/**
 * @describle 蓝图试卷结构大题详情 controller
 * @author Administrator
 * @date   2017.11.20
 */
@Controller
@RequestMapping("${api_cqb}/")
public class PaperDetailInfoStructBlueprintController {
	
	@Autowired
	private PaperDetailInfoStructBlueprintService paperDetailInfoStructBlueprintService;

	@ApiOperation(value="保存蓝图试卷结构大题详情" , notes="保存蓝图试卷结构大题详情")
	@PostMapping(value="/paperDetailInfoStructBlueprint/save")
	public ResponseEntity<Object> saveDto(HttpServletRequest request,@RequestBody PaperDetailInfoStructBlueprintDto paperDetailInfoStructBlueprintDto){
		AccessUser accessUser = (AccessUser) request.getAttribute("accessUser");
		if(accessUser == null){
			return new ResponseEntity<Object>(HttpStatus.NOT_FOUND);
		}
		paperDetailInfoStructBlueprintService.saveDto(paperDetailInfoStructBlueprintDto);
		return new ResponseEntity<Object>(HttpStatus.OK);
	}
	
	@ApiOperation(value="根据蓝图试卷结构大题Id查询大题详情", notes="不带分页")
	@GetMapping(value="/paperDetailInfoStructBlueprint/{paperDetailStructBlueprintId}")
	public ResponseEntity<Object> findByPaperDetailStructBlueprintId(HttpServletRequest request,@PathVariable Long paperDetailStructBlueprintId){
		AccessUser accessUser = (AccessUser) request.getAttribute("accessUser");
		if(accessUser == null){
			return new ResponseEntity<Object>(HttpStatus.NOT_FOUND);
		}
		PaperDetailInfoStructBlueprintDto paperDetailInfoStructBlueprintDto = paperDetailInfoStructBlueprintService.findByPaperDetailStructBlueprintId(paperDetailStructBlueprintId);
		return new ResponseEntity<Object>(paperDetailInfoStructBlueprintDto,HttpStatus.OK);
	}
}
